
from HTMLParser import HTMLParser, HTMLParseError

class Tabla(list):
    def __init__(self, attrs):
        self.attrs = dict(attrs)
        super(list, self).__init__(self)

class Info(str):
    def __new__(cls, texto, link):
        self = str.__new__(cls, texto)
        self.link = link
        return self

    def __repr__(self):
        return "%s (%s)" % (self, self.link)

class tableConstructor(object):
    def __init__(self):
        self.all_tablas = []
        self.dataUtil = False
        self.tagsUtiles = ("table", "tr", "th", "td", "a")
        self.enTabla = self.enFila = self.enCampo = self.enCabec = False
        self.anchor = None

    def start_table(self, attrs):
        self.end_table()
        self.tabla = Tabla(attrs)
#        print "-------\nArrancando tabla", attrs
        self.enTabla = True
    def end_table(self):
        if not self.enTabla:
            return
        self.all_tablas.append(self.tabla)
#        print "-------\nFin tabla\n", self.tabla
        self.enTabla = False

    def start_tr(self, attrs):
        self.end_tr()
#        print "-------\nArrancando fila", attrs
        self.fila = []
        self.enFila = True
    def end_tr(self):
        if not self.enFila:
            return
        self.tabla.append(self.fila)
#        print "-------\nFin fila\n", self.fila
        self.enFila = False
        self.enCampo = False

    def start_th(self, attrs):
        self.end_th()
        self.cabec = []
#        print "-------\nArrancando cabec", attrs
        self.enCabec = True
        self.anchor = None
    def end_th(self):
        if not self.enCabec:
            return
        texto = "".join(self.cabec).strip()
        info = Info(texto, self.anchor)
        self.fila.append(info)
#        print "-------\nFin cabec\n", repr(info)
        self.enCabec = False
        self.anchor = None
        
    def start_td(self, attrs):
        self.end_td()
        self.campo = []
#        print "-------\nArrancando campo", attrs
        self.enCampo = True
        self.anchor = None
    def end_td(self):
        if not self.enCampo:
            return
        texto = "".join(self.campo).strip()
        info = Info(texto, self.anchor)
        self.fila.append(info)
#        print "-------\nFin campo\n", info
        self.enCampo = False
        self.anchor = None
        
    def feed(self, data):
        if self.enCampo:
#            print "++", data
            self.campo.append(data)
        if self.enCabec:
#            print "++", data
            self.cabec.append(data)

    def start_a(self, attrs):
        for (head, param) in attrs:
            if head == "href":
                self.anchor = param
                return
    def end_a(self):
        pass
        

class MyHTMLParser(HTMLParser):

    def __init__(self, constructor):
        self.constructor = constructor
        HTMLParser.__init__(self)
        self._fillHandlers()

    def _fillHandlers(self):
        self.tagHandlers = {}
        for tag in self.constructor.tagsUtiles:
            self.tagHandlers["start", tag] = getattr(self.constructor, "start_"+tag)
            self.tagHandlers["end", tag] = getattr(self.constructor, "end_"+tag)

    def handle_starttag(self, tag, attrs):
#        print "Encountered the beginning of a %s tag" % tag
        if tag in self.constructor.tagsUtiles:
#            print "Llamando a start", tag
            handler = self.tagHandlers[("start", tag)]
            handler(attrs)

    def handle_endtag(self, tag):
#        print "Encountered the end of a %s tag" % tag
        if tag in self.constructor.tagsUtiles:
#            print "Llamando a end", tag
            handler = self.tagHandlers[("end", tag)]
            handler()

    def handle_data(self, data):
#        print "Llamando con data", data
        self.constructor.feed(data)
